unit JMDesignerForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, TypInfo,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Math, Grids, Menus, JMFormDesign, JMFunc,
  ImgList, JvBlinkingLabel, JvLabel, JvAppearingLabel, JvComponent,
  JvOLBar, JvLinkLabel, TeeProcs, TeEngine, Chart, Buttons, JvCaptionPanel,
  JvRadioCtl, JvCombobox, JvColorCombo, Mask, JvZoom, JvToolEdit,
  JvCurrEdit, JL3Settings, CheckLst;

type
  TSG = class(TStringGrid);
  TForm1 = class(TForm)
    miNormal: TMenuItem;
    Panel1: TPanel;
    Memo1: TMemo;
    Image1: TImage;
    Label1: TLabel;
    Button1: TButton;
    MainMenu1: TMainMenu;
    miDesign: TMenuItem;
    miLayOut: TMenuItem;
    miDefault: TMenuItem;
    miSave: TMenuItem;
    miSaveAs: TMenuItem;
    miLoad: TMenuItem;
    N1: TMenuItem;
    miSaveStartControl: TMenuItem;
    LoadStartControl1: TMenuItem;
    ImageList1: TImageList;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet: TTabSheet;
    Labels: TLabel;
    Edit1: TEdit;
    Memo: TMemo;
    Button: TButton;
    CheckBox1: TCheckBox;
    RadioButton: TRadioButton;
    GroupBox: TGroupBox;
    BitBtn: TBitBtn;
    StringGrid: TStringGrid;
    ScrollBox: TScrollBox;
    ColorBox: TColorBox;
    JvBlinkingLabel1: TJvBlinkingLabel;
    JvRadioControl1: TJvRadioControl;
    JvCaptionPanel: TJvCaptionPanel;
    JvCalcEdit: TJvCalcEdit;
    ComboBoxEx: TComboBoxEx;
    JvZoom: TJvZoom;
    JMFD: TJMFormDesign;
    Panel: TPanel;
    Timer: TTimer;
    MonthCalendar1: TMonthCalendar;
    gbOptions: TGroupBox;
    ControlList: TComboBoxEx;
    clbOptions: TCheckListBox;
    BluePanel: TPanel;
    procedure ControlClick(Sender: TObject);
    procedure ControlMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure TimerTimer(Sender: TObject);
    procedure miClick(Sender: TObject);
    procedure RefreshList(Sender: TObject);
    procedure ControlListChanged(Sender: TJMFormDesign;
      Component: TComponent; Key: String);
    procedure SettingChanged(Sender: TObject);
    procedure JMFDSelectionChanged(Sender: TJMFormDesign;
      Component: TComponent; Key: String);
  end;
var
  Form1: TForm1;

implementation

{$R *.dfm}
{ Test Events - Not necessary }
procedure TForm1.ControlClick(Sender: TObject);
begin
  ShowMessage('You have clicked ' + TComponent(Sender).Name + ' : ' + Sender.ClassName);
end;

procedure TForm1.ControlMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin // Demo of how to SaveCode when the sender can be different kind of component
  if IsPublishedProp(Sender,'Caption') then SetPropValue(Sender,'Caption',Format('%d,%d',[X,Y]));
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin // Timer test event.  Note that the Target is Hardcoded so it cannot apply to other MonthCalendar;
  MonthCalendar1.Date := MonthCalendar1.Date + 1;
end;

{ Methods to maintain the Setting Panel - Not necessary if no need to let user choose }
procedure TForm1.RefreshList(Sender: TObject);
var i : integer;
  procedure FillList(C : TControl; Lv : integer);
  var i, idx : integer;
  begin
    idx := JMFD.ImgClassName.IndexOf(C.ClassName);
    if C.Name <> '' then ControlList.ItemsEx.AddItem(C.Name + ' : ' + C.ClassName,idx,idx,0,Lv,C);
    if C is TWinControl then
      for i := 0 to TWinControl(C).ControlCount - 1 do
        FillList(TWinControl(C).Controls[i],Lv + 1);
  end;
begin // Make up the Start Control List
  ControlList.Clear;
  FillList(self,0);
  ControlList.ItemIndex := ControlList.Items.IndexOfObject(JMFD.StartControl);
  for i := 0 to clbOptions.Count - 1 do
    clbOptions.Checked[i] := TJMFDOption(i) in JMFD.Options;
end;

procedure TForm1.SettingChanged(Sender: TObject);
var i : integer;
    Designing : Boolean;
    Opts : TJMFDOptions;
begin  // Update the FormDesign Setting when it changed
  Designing := JMFD.Designing;
  JMFD.EndDesign;
  Opts := JMFD.Options;
  for i := 0 to clbOptions.Count - 1 do
    if clbOptions.Checked[i] then Include(Opts,TJMFDOption(i)) else Exclude(Opts,TJMFDOption(i));
  JMFD.Options := Opts;
  JMFD.StartControl := TControl(ControlList.Items.Objects[ControlList.ItemIndex]);
  if Designing then JMFD.StartDesign;
end;

procedure TForm1.ControlListChanged(Sender: TJMFormDesign; Component: TComponent; Key: String);
begin //  Event Called when Component Added / Deleted
  if Component is TControl then RefreshList(Sender);
end;

procedure TForm1.JMFDSelectionChanged(Sender: TJMFormDesign; Component: TComponent; Key: String);
begin //  Demo how to change the behavior of Editing for some Component
  if Component = gbOptions then
    Sender.Options := Sender.Options - [joCanResize,joShowProperties,joShowEvents]
  else
    Sender.Options := Sender.Options + [joCanResize,joShowProperties,joShowEvents];
end;

{ The only needed method to manupluate JMFD in response to main menu }
procedure TForm1.miClick(Sender: TObject);
begin  // Save/Load and Start/End Design
  Case TMenuItem(Sender).Tag of
   1 : JMFD.SaveLoad(smDefault);
   2 : JMFD.SaveLoad(smSave,Self,JMFD.FileName);
   3 : JMFD.SaveLoad(smSave,Self);
   4 : JMFD.SaveLoad(smLoad,Self);
   5 : JMFD.SaveLoad(smSave,JMFD.StartControl);
   6 : JMFD.SaveLoad(smLoad,JMFD.StartControl);
  11 : JMFD.StartDesign;
  12 : JMFD.EndDesign;
  end;
end;

end.
