unit JMFDPalette;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ToolWin, ComCtrls, ExtCtrls, StdCtrls, JMInterface, JMFormDesign, ImgList;

type
  TTB = Class(TToolButton);
  TJMFDPaletteFm = class(TForm,IJMFDPalette)
    Holder: TPageControl;
    AddGB: TGroupBox;
    AddImg: TImage;
    ToolBar1: TToolBar;
    tbCut: TToolButton;
    tbCopy: TToolButton;
    tbPaste: TToolButton;
    tbDelete: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    tbDefault: TToolButton;
    tbOptions: TToolButton;
    ImageList2: TImageList;
    procedure CancelClick(Sender: TObject);
    procedure BtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ActionClick(Sender: TObject);
  private
    PalItem : TStrings;
    FormDesign : TJMFormDesign;
    ActiveIndex : Integer;
  public
    procedure SetFormDesign(const Value : TComponent; Items : TStrings);
    function GetActiveIndex : Integer;
    Procedure ResetIndex;
  end;

var
  JMFDPaletteFm: TJMFDPaletteFm;

implementation

{$R *.dfm}

procedure TJMFDPaletteFm.SetFormDesign(const Value: TComponent; Items : TStrings);
var
i : integer;
IO : TPalData;
Pg : TTabSheet;
Tb : TToolBar;
Btn : TToolButton;
  procedure CreatePage;
  begin
    Pg := TTabSheet.Create(Holder);
    Pg.PageControl := Holder;
    Pg.Caption := IO.Palette;
    Tb := TToolBar.Create(Pg);
    Tb.Parent := Pg;
    Tb.EdgeBorders := [];
    Tb.EdgeInner := esNone;
    Tb.EdgeOuter := esNone;
    if Assigned(FormDesign.Images) then Tb.Images := FormDesign.Images;
    Tb.Flat := true;
    Tb.ButtonWidth := 28;
    Tb.ButtonHeight := 28;
    Holder.ActivePage := Pg;
  end;
  procedure AddItem;
  begin
    Tb := TToolBar(Holder.ActivePage.Controls[0]);
    Btn := TToolButton.Create(Tb);
    TTB(Btn).SetToolBar(Tb);
    btn.Hint := PalItem[i] + ' : ' + IO.AClassName;
    btn.ImageIndex := FormDesign.ImgClassName.IndexOf(IO.AClassName);
    btn.Tag := i;
    btn.OnClick := BtnClick;
    btn.Left := Tb.ButtonCount * Tb.ButtonWidth;
  end;
begin
  if Value = nil then exit;
  FormDesign := TJMFormDesign(Value);
  PalItem := Items;
  for i := Holder.PageCount - 1 downto 0 do Holder.Pages[i].Free;
  for i := 0 to PalItem.Count -1 do
  begin
    IO := TPalData(PalItem.Objects[i]);
    if (i = 0) or (Holder.ActivePage.Caption <> IO.Palette) then
      CreatePage;
    AddItem;
  end;
end;

function TJMFDPaletteFm.GetActiveIndex: Integer;
begin
  result := ActiveIndex;
end;

procedure TJMFDPaletteFm.ResetIndex;
begin
  CancelClick(nil);
end;

procedure TJMFDPaletteFm.CancelClick(Sender: TObject);
begin
  ActiveIndex := -1;
  AddImg.Picture.Bitmap := nil;
  AddImg.Hint := '';
end;

procedure TJMFDPaletteFm.BtnClick(Sender: TObject);
begin
  ActiveIndex := TToolButton(Sender).Tag;
  AddImg.Hint := TToolButton(Sender).Hint;
  if Assigned(FormDesign.Images) then
  begin
    AddImg.Picture.Bitmap := nil;
   FormDesign.Images.Draw(AddImg.Canvas,0,0,ActiveIndex);
  end;
end;

procedure TJMFDPaletteFm.FormShow(Sender: TObject);
begin
  Holder.ActivePageIndex := 0;
  CancelClick(Sender);
end;

procedure TJMFDPaletteFm.ActionClick(Sender: TObject);
begin
  Case TToolButton(Sender).ImageIndex of
  0 : FormDesign.CutComponent;
  1 : FormDesign.CopyComponent;
  2 : FormDesign.PasteComponent;
  3 : FormDesign.DeleteComponent;
  4 : FormDesign.SaveLoad(smLoad,FormDesign.Form);
  5 : FormDesign.SaveLoad(smSave,FormDesign.Form);
  6 : FormDesign.SaveLoad(smDefault);
  7 : FormDesign.EndDesign;
  end;
end;

initialization
  RegisterClass(TJMFDPaletteFm);

end.
